Title EXEC program using undocumented MS-DOS Interrupt 2EH

;
; This little demonstration program illustrates the undocumented
; MS-DOS Int 2EH route to the command interpreter in COMMAND.COM.
; In this example we just pass the command tail of the line that
; loaded the EXEC2E program.
;
; by David Gwillim - 20 June 1986
; Appears to work on all current versions of MS-DOS (2.x-3.1)
; Adapted from Turbo Pascal program written by Russ Nelson, Potsdam, NY.
;

cseg    segment

        org  100H

        assume cs:cseg,ds:nothing       ; force assembler to provide
                                        ; CS overrides in the right places

begin:  jmp     start

        db      20 dup ('STACK ')     
stack   equ     $

stkseg  dw      0                       ; save SS register
stkptr  dw      0                       ; save SP register

msg1    db      'Beginning DOS Int 2Eh Exec',13,10,'$'

msg2    db      'Terminating DOS Int 2Eh Exec',13,10,'$'

start:  push    cs                      ;make our local data addressable
        pop     ds

        mov     dx,offset msg1          ;display sign-on message
        mov     ah,9
        int     21h

        mov     sp,offset stack         ;reset SP to our own internal stack

        mov     bx,offset cs:endcode    ;Get the offset of the end of our code
        shr     bx,1                    ;divide by 16 to get paragraphs
        shr     bx,1
        shr     bx,1
        shr     bx,1
        inc     bx                      ;round paragraphs up
        mov     ah,4ah                  ;shrink down this COM program's
        int     21h                     ;memory allocation to what's needed

        mov     stkseg,ss               ;save our current SS reg
        mov     stkptr,sp               ; and SP reg values

        mov     si,80h                  ;let DS:SI point to the command
                                        ;to be executed 

        int     2eh                     ;undocumented DOS exec interrupt
                                        ; any error code is now in AX           
  

        mov     ss,stkseg               ;Restore SS and SP registers
        mov     sp,stkptr

        push    cs                      ;restore local addressing
        pop     ds

        mov     dx,offset msg2          ;say we're done
        mov     ah,9
        int     21h

        mov     ax,4c00h                ;exit to DOS
        int     21h

endcode equ     $

cseg    ends

        end   begin

