.nolist
ifndef	PROCESOR_INC

comment #
	PROCESOR.INC						V1.00
==========================================================================
NAME
	PROCESOR.INC		Processor designation include file

DESCRIPTION
	This include file is used to specify the processor for which the
	.asm files will be assembled.  Placing the processor directive in
	this include file allows the changing of the processor without
	changing the source code.

	Selection of a processor enables assembly of all earlier processor
	instructions.

	Selection of the processor enables assembly of the coprocessor
	instructions.

	Acceptable values are:
	.8086	-> enables assembly of 8086 and 8087 instructions only
	.8087	-> enables assembly of 8087 instructions
	.186	-> enables assembly of 80186 instructions
	.286	-> enables assembly of real mode 80286 instructions
	.287	-> enables assembly of 80287 instructions
	.286P	-> enables assembly of both real and protected mode 80286
		   instructions
	.386	-> enables assembly of real mode 80386 instructions
	.387	-> enables assembly of 80387 instructions
	.386P	-> enables assembly of both real and protected mode 80386
		   instructions
	.486	-> enables assembly of real mode 80486 instructions
	.486P	-> enables assembly of both real and protected mode 80486
		   instructions

AUTHOR
	Raymond Moon
	Copyright 1992 - Raymond Moon
	ALL RIGHTS RESERVED

HISTORY
	Version - Date		- Remarks
	1.00	19 Jan 92	- Orginal
	1.01	15 Aug 92	- Completed Description of all MASM 6.0 Options
				- Added PROCESOR_INC equate and test
	#

;----------------------------
;	Define equate to identify this include file to preclude being
;	included more than once.

PROCESOR_INC	equ	1

;----------------------------
;	Specify target processor.

	.286

endif
.list
