; SPEED.ASM                                     Last updated Sept/17/94
;                                   CopyRight (C) 1994, Greg Estabrooks
; PURPOSE:
;       Command line utility to switch between Turbo and Normal CPU 
;       speeds. Allowing speed to be changed in batch files,etc.
;
; NOTE: Should only work on Computers that Allow the CTRL-ALT+ or
;       CTRL-ALT- keys to change the speed. Affects on others are
;       unknown.
;
; Disclaimer: You are free to use this program as long as you want or 
;             rewrite it to your likeing however I make no guarantees 
;             that it will actually work on your computer only that it 
;             will take up disk space. I accept NO responsibility for 
;             any damage caused. Have a nice day.


        .MODEL TINY
        .CODE
        Org     100h
        
Print  Macro Msg
        Mov DX,Offset &Msg          ; Load offset of message to write.    
        Call Write                  ; Write the message.
       EndM 

Begin: Jmp Main                     ; Go to work.

Write Proc                          ; Routine to print a string.    
        Mov AH,09h                  ; DOS Function to print a string.    
        Int 21h                     ; Call DOS.    
        Ret
Write EndP

SetSpeed Proc                       ; Routine to actually trick the 
                                    ; computer into changing speeds.
        Push AX
        Mov AX,40h
        Mov ES,AX
        Mov AH,BYTE PTR ES:[17h]
        Mov OldMem,AH
        Mov BYTE PTR ES:[17h],140
        Pop AX
        
        Mov AH,4Fh
        Int 15h
        
        Mov AH,OldMem
        Mov BYTE PTR ES:[17h],AH
        Ret
SetSpeed EndP

Main Proc
        Print Prog
        
        Cmp BYTE PTR DS:[80h],2
        Jne SSyntax
        
TestFunc:        
        Mov AH,BYTE PTR DS:[82h]
        Cmp AH,'t'
        Je STurbo
        Cmp AH,'T'
        Je STurbo
        
        Cmp AH,'n'
        Je SNorm
        Cmp AH,'N'
        Je SNorm
        
SSyntax:Print Syntax
        Jmp Exit
SNorm:
        Print Msg
        Print Norm
        Mov AL,74
        Call SetSpeed
        Jmp Exit

STurbo: 
        Print Msg
        Print Turbo
        Mov AL,78
        Call SetSpeed
        
Exit:        
        Ret
Main EndP

 Msg    DB " - Setting speed to$"
 Turbo  DB " TURBO mode!",13,10,"$"
 Norm   DB " NORMAL mode!",13,10,"$" 
 OldMem DB ?
 Prog   DB " CPU Speed Switch V0.02  - "
        DB "Copyright (C) 1994 Greg Estabrooks ",13,10,"$"
        
 Syntax DB "  Usage : SPEED [T/N]",13,10
        DB "             T = Turbo mode.",13,10
        DB "             N = Normal mode.",13,10,"$"
        
End Begin        
