;
;
;    (CEVS) Cross-Eyed Viking Solutions 
;
;   PCX Unit 1.0 / 286 for real mode.
;   Lorne Kirkland Chartier (1996) - public domain.
;
;


;
;
;    Data Structures
;
;

; PCX Header Structure
PCX_Hdr struc
  pcxhmanufact  db ?                            ; manufacturer, must be 0ah
  pcxhversion   db ?                            ; version, >= 5 for 256 color
  pcxhencoding  db ?                            ; encoding, must be 1
  pcxhbitsppix  db ?                            ; bits per pixel (8)
  pcxhxmin      dw ?                            ; x min dimension (usually 0)
  pcxhymin      dw ?                            ; y min dimension (usually 0)
  pcxhxmax      dw ?                            ; x max (width = xmax-xmin+1)
  pcxhymax      dw ?                            ; y max (depth = ymax-ymin+1)
  pcxhhres      dw ?                            ; useless
  pcxhvres      dw ?                            ; useless
  pcxhpalette   db 48 dup (?)                   ; useless (16 color)
  pcxhresv1     db ?
  pcxhcplanes   db ?                            ; color planes, 1 for 256 color
  pcxhbspline   dw ?                            ; bytes per line
  pcxhpaltype   dw ?                            ; 1 = greyscale, 2 = color
  pcxhresv2     db 58 dup (?)
PCX_Hdr ends


ifndef H_PCX
;
;
;    Functions
;
;

extrn           pascal pcxreadhdr:far           ; read a pcx header
extrn           pascal pcxdecode:far            ; decode a pcx picture

extrn           pascal pcxwritehdr:far          ; write a pcx header
extrn           pascal pcxencode:far            ; encode a pcx picture

endif

