;
;
;    (CEVS) Cross-Eyed Viking Solutions 
;
;   Timer 1.0 / 286 for real mode.
;   Taken from TIMER1.ASM - David Kirschbaum, Toad Hall.
;
;

                .286p
                .model medium, pascal
                jumps

                .code

;
;   timerinit() - initialize high resolution timer
;   pass:       nothing
;   returns:    nothing
;

                public timerinit

timerinit       proc pascal

                mov al,34h
                jmp short common

timerinit       endp


;
;   timerdnit() - de-initialize high resolution timer
;   pass:       nothing
;   returns:    nothing
;

                public timerdnit

timerdnit       proc pascal

                mov al,36h                      ; outp(0x043,0x036);
common:
                mov dx,43H
                out dx,al
                jmp short $+2

                mov dx,40H                      ; outp(0x040,0x000);
                xor ax,ax
                out dx,al
                jmp short $+2

                out dx,al                       ; outp(0x040,0x000);

                ret
timerdnit       endp


;
;   timerread() - read the high resolution timer
;   pass:       nothing
;   returns:    dx:ax - 32-bit timer value
;

                public timerread

timerread       proc pascal
                uses di, si

                cli                             ; Disable interrupts
                mov dx,020h                     ; Address PIC ocw3
                mov al,00Ah                     ; Ask to read irr
                out dx,al
                mov al,00h                      ; Latch timer 0
                out 043h,al
                in  al,dx                       ; Read irr
                mov di,ax                       ; Save it in DI
                in  al,040h                     ; Counter --> bx
                mov bl,al                       ; LSB in BL
                in  al,040h
                mov bh,al                       ; MSB in BH
                not bx                          ; Need ascending counter
                in  al,021h                     ; Read PIC imr
                mov si,ax                       ; Save it in SI

                mov al,00FFh                    ; Mask all interrupts
                out 021h,al
                mov ax,040h                     ; read low word of time
                mov es,ax                       ; from BIOS data area
                mov dx,es:[06Ch]                ; here's the timer long.hi

                mov ax,si                       ; Restore imr from SI
                out 021h,al

                sti                             ; Enable interrupts
                mov ax,di                       ; Retrieve old irr
                test al,001h                    ; Counter hit 0?
                jz  Done                        ; Jump if not
                cmp bx,0FFh                     ; Counter > 0x0FF?
                ja  Done                        ; Done if so
                inc dx                          ; Else count int req.
Done:
                mov ax,bx                       ; set function result

                ret
timerread       endp

                end

